{ open Parser }
(* TOKEN RULE MAPPING FOR STRINGS *)
rule token = parse
  [' ' '\t' '\r'] { token lexbuf } (* Whitespace *)
| "@>"     { comment lexbuf }    
| "@"	   { singcomment lexbuf }       (* Comments *)
| '('      { LPAR }
| ')'      { RPAR }
| '{'      { LBRACE }
| '}'      { RBRACE }
| '\n'     { NEWLINE }
| ';'      { SEMI }
| ','      { COMMA }
| '*'      { MULT }
| '+'      { ADD }
| "+="	   { ADDASSN }
| "-="	   { MINUSASSN }
| "/="	   { DIVASSN }
| "*="	   { MULTASSN }
| "++"	   { INCREMENT }
| "--" 	   { DECREMENT}
| '-'      { SUB }
| '/'      { DIV }
| "^^"	   { SQUARE }
| '~'      { POWER }
| '!'	   { FACTORIAL }
| '='      { ASSIGN }
| "=="     { EQ }
| "!="     { NEQ }
| '<'      { LT }
| '%'	   { MODULUS }
| "<="     { LEQ }
| ">"      { GT }
| ">="     { GEQ }
| "if"     { IF }
| "else"   { ELSE }
| "for"    { FOR }
| "endfor" { ENDFOR }
| "endif"  { ENDIF }
| "return" { RETURN }
| "int"    { INT }
| "while" { WHILE }
| "endwhile" { ENDWHILE}
| "fn" { FN }
| "endfn" { ENDFN }
| ['0'-'9']+ as lxm { LITERAL(int_of_string lxm) }
| ['a'-'z' 'A'-'Z']['a'-'z' 'A'-'Z' '0'-'9' '_']* as lxm { ID(lxm) }
| eof { EOF }
| _ as char { raise (Failure("illegal character " ^ Char.escaped char)) }

and comment = parse
  "<@\n" { token lexbuf }
| _    { comment lexbuf }

and singcomment = parse
	"\n" {token lexbuf}
| _ { singcomment lexbuf }
